#ifndef _SKEY_VIEW_H
#	define _SKEY_VIEW_H

#include <interface/View.h>
#include <kernel/OS.h>

#define SKEY_COMP_KEY 'SKCv'
#define COPY_MSG	'SCPw'
#define PASTE_MSG	'SPTw'
#define MD4_MSG		'SMD4'
#define MD5_MSG		'SMD5'

#define SEED_PROMPT		"Enter Seed:"
#define KEY_PROMPT		"Enter Secret Key:"
#define PW_MESS			"S/Key Password:"

#define BUTTON_LABEL	"Compute Password"
#define BUTTON_WIDTH 	125
#define OTP_BOX_WIDTH	250
#define OTP_BOX_HEIGHT	40

class OTPView: public BView {
private:
	char data[256];
	sem_id output_sem;
	font_info font;

public:
	OTPView(BRect frame);

	void AttachedToWindow();
	void Draw(BRect update_rect);
	void SetText(const char *string);
	const char *Text();	
};

class SKeyView: public BView {
private:
	BTextControl *SeedView;
	OTPView *KeyView;
	BTextControl *PWView;
	
	bool md4;

public:
	SKeyView(BRect frame);
	
	void AttachedToWindow();
	void MessageReceived(BMessage *msg);
};

// TODO: Move me somewhere more appropriate.
char *ComputeKey(const char *seed, const char *key, bool md4);

#endif
