#include "SKeyWindow.h"
#include "SKeyView.h"

#include <Window.h>

float SKeyWindow::AddMenuBar(BRect frame)
{
	menu_bar = new BMenuBar(frame, "window menu");
	
	// Create Edit menu.
	BMenu *edit = new BMenu("Edit");
	BMenuItem *item = new BMenuItem("Copy S/Key Password",
									new BMessage(COPY_MSG), 'C');
	item->SetTarget(this);
	edit->AddItem(item);
	item = new BMenuItem("Paste Seed", new BMessage(PASTE_MSG), 'V');
	item->SetTarget(this);
	edit->AddItem(item);

	menu_bar->AddItem(edit);
	AddChild(menu_bar);

	Lock();
	float ret_val = menu_bar->Bounds().bottom;
	Unlock();

	return ret_val;
}

SKeyWindow::SKeyWindow(BRect frame)
		   : BWindow(frame, "S/Key", B_TITLED_WINDOW,
					 B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
	SetDiscipline(TRUE);

	frame.OffsetTo(B_ORIGIN);

	// Add the menu bar.
	BRect view_frame = BRect(0, 0, 0, 0);

	view_frame.top = AddMenuBar(view_frame);
	view_frame.bottom = frame.bottom;
	view_frame.left = 0; view_frame.right = frame.right;

	// Add the view.
	view = new SKeyView(view_frame);
	AddChild(view);
	Show();
}

void SKeyWindow::MessageReceived(BMessage *msg)
{
	switch (msg->what) {
	case MD4_MSG:
	case MD5_MSG:
	case PASTE_MSG:
	case COPY_MSG:
	case SKEY_COMP_KEY:
		view->MessageReceived(msg);
		break;
	default:
		BWindow::MessageReceived(msg);
	}
}

bool SKeyWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	
	return TRUE;
}
